Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxextension.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxextension.c
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxextension.c
@@ -1562,11 +2061,68 @@ static void dmxBEDestroyWindowTree(int i
     }
 }
 
+void
+dmxDisableScreen (int idx)
+{
+    ScreenPtr     pScreen;
+    DMXScreenInfo *dmxScreen;
+    int           i;
+
+    pScreen = screenInfo.screens[idx];
+    dmxScreen = &dmxScreens[idx];
+
+    dmxLogOutput(dmxScreen, "Disable screen #%d\n", idx);
+
+    dmxInputDisable (&dmxScreen->input);
+
+#ifdef XV
+    dmxBEXvScreenFini (pScreen);
+#endif
+
+#ifdef RANDR
+    dmxBERRScreenFini (pScreen);
+#endif
+
+    /* Save all relevant state (TODO) */
+
+    /* Free all non-window resources related to this screen */
+    for (i = currentMaxClients; --i >= 0; )
+	if (clients[i])
+	    FindAllClientResources(clients[i], dmxBEDestroyResources,
+				   (pointer)idx);
+
+    /* Free scratch GCs */
+    dmxBEDestroyScratchGCs(idx);
+
+    /* Free window resources related to this screen */
+    dmxBEDestroyWindowTree(idx);
+
+    /* Free default stipple */
+    dmxBESavePixmap(pScreen->PixmapPerDepth[0]);
+    dmxBEFreePixmap(pScreen->PixmapPerDepth[0]);
+
+    if (pScreen->pScratchPixmap)
+	dmxBEFreePixmap(pScreen->pScratchPixmap);
+
+    /* Free the remaining screen resources and close the screen */
+    dmxBECloseScreen(pScreen);
+
+    /* Screen is now disabled */
+    dmxScreen->beDisplay = NULL;
+
+    /* Make sure we don't have any pending sync replies */
+    dmxScreenSyncReply (pScreen, 0, NULL, NULL, 0);
+
+#ifdef RANDR
+    RRGetInfo (screenInfo.screens[0]);
+#endif
+
+}
+
 /** Detach back-end screen. */
 int dmxDetachScreen(int idx)
 {
-    DMXScreenInfo *dmxScreen = &dmxScreens[idx];
-    int            i;
+    DMXScreenInfo *dmxScreen;
 
     /* Return failure if dynamic addition/removal of screens is disabled */
     if (!dmxAddRemoveScreens) {
@@ -1584,8 +2140,17 @@ int dmxDetachScreen(int idx)
     /* Cannot remove a screen that does not exist */
     if (idx < 0 || idx >= dmxNumScreens) return 1;
 
+    dmxScreen = &dmxScreens[idx];
+
+    if (idx == 0) {
+	dmxLog(dmxWarning,
+	       "Attempting to remove screen #%d\n",
+	       idx);
+	return 1;
+    }
+
     /* Cannot detach from a screen that is not opened */
-    if (!dmxScreen->beDisplay) {
+    if (!dmxScreen->beAttachedDisplay && !dmxScreen->beDisplay) {
 	dmxLog(dmxWarning,
 	       "Attempting to remove screen #%d but it has not been opened\n",
 	       idx);
@@ -1594,32 +2159,60 @@ int dmxDetachScreen(int idx)
 
     dmxLogOutput(dmxScreen, "Detaching screen #%d\n", idx);
 
+    if (dmxScreen->beDisplay)
+	dmxDisableScreen (idx);
+
     /* Detach input */
-    dmxInputDetachAll(dmxScreen);
+    dmxInputDetach (&dmxScreen->input);
 
-    /* Save all relevant state (TODO) */
+    dmxScreen->beDisplay = dmxScreen->beAttachedDisplay;
+    dmxCloseDisplay (dmxScreen);
 
-    /* Free all non-window resources related to this screen */
-    for (i = currentMaxClients; --i >= 0; )
-	if (clients[i])
-	    FindAllClientResources(clients[i], dmxBEDestroyResources,
-				   (pointer)idx);
+    dmxScreen->beAttachedDisplay = NULL;
+    dmxScreen->beDisplay = NULL;
 
-    /* Free scratch GCs */
-    dmxBEDestroyScratchGCs(idx);
+    dmxScreen->scrnWidth   = 1;
+    dmxScreen->scrnHeight  = 1;
+    dmxScreen->rootX       = 0;
+    dmxScreen->rootY       = 0;
+    dmxScreen->beWidth     = 1;
+    dmxScreen->beHeight    = 1;
+    dmxScreen->beXDPI      = 75;
+    dmxScreen->beYDPI      = 75;
+    dmxScreen->beDepth     = 24;
+    dmxScreen->beBPP       = 32;
 
-    /* Free window resources related to this screen */
-    dmxBEDestroyWindowTree(idx);
+    if (dmxScreen->name)
+    {
+	free (dmxScreen->name);
+	dmxScreen->name = NULL;
+    }
 
-    /* Free default stipple */
-    dmxBESavePixmap(screenInfo.screens[idx]->PixmapPerDepth[0]);
-    dmxBEFreePixmap(screenInfo.screens[idx]->PixmapPerDepth[0]);
+    if (dmxScreen->display)
+    {
+	free (dmxScreen->display);
+	dmxScreen->display = NULL;
+    }
 
-    /* Free the remaining screen resources and close the screen */
-    dmxBECloseScreen(screenInfo.screens[idx]);
+    if (dmxScreen->authType)
+    {
+	free (dmxScreen->authType);
+	dmxScreen->authType = NULL;
+    }
+
+    dmxScreen->authTypeLen = 0;
+
+    if (dmxScreen->authData)
+    {
+	free (dmxScreen->authData);
+	dmxScreen->authData = NULL;
+    }
+
+    dmxScreen->authDataLen = 0;
 
-    /* Adjust the cursor boundaries (paints detached console window) */
-    dmxAdjustCursorBoundaries();
+#ifdef RANDR
+    RRGetInfo (screenInfo.screens[0]);
+#endif
 
     return 0; /* Success */
 }
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxextension.h
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxextension.h
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxextension.h
@@ -42,6 +42,7 @@
 /** Screen attributes.  Used by #ProcDMXGetScreenAttributes and
  * #ProcDMXChangeScreenAttributes. */
 typedef struct {
+    const char   *name;
     const char   *displayName;
     int          logicalScreen;
 
@@ -95,6 +96,8 @@ extern Bool          dmxGetScreenAttribu
                                             DMXScreenAttributesPtr attr);
 extern Bool          dmxGetWindowAttributes(WindowPtr pWindow,
                                             DMXWindowAttributesPtr attr);
+extern Bool          dmxGetDrawableAttributes(DrawablePtr pDraw,
+					      DMXWindowAttributesPtr attr);
 extern void          dmxGetDesktopAttributes(DMXDesktopAttributesPtr attr);
 extern int           dmxGetInputCount(void);
 extern int           dmxGetInputAttributes(int deviceId,
@@ -113,6 +116,24 @@ extern int           dmxConfigureDesktop
 extern void          dmxUpdateScreenResources(ScreenPtr pScreen,
                                               int x, int y, int w, int h);
 
-extern int           dmxAttachScreen(int idx, DMXScreenAttributesPtr attr);
+
+typedef void (*dmxErrorSetProcPtr) (void       *error,
+				    const char *name,
+				    const char *format,
+				    ...);
+
+extern void          dmxEnableScreen(int idx);
+extern void          dmxDisableScreen(int idx);
+
+extern int           dmxAttachScreen (int                    idx,
+				      DMXScreenAttributesPtr attr,
+				      unsigned int	     window,
+				      const char             *authType,
+				      int                    authTypeLen,
+				      const char             *authData,
+				      int                    authDataLen,
+				      dmxErrorSetProcPtr     errorSet,
+				      void		     *error,
+				      const char             *errorName);
 extern int           dmxDetachScreen(int idx);
 #endif
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxfont.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxfont.c
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxfont.c
@@ -38,8 +38,6 @@
 #include <dmx-config.h>
 #endif
 
-#define DMX_FONTPATH_DEBUG 0
-
 #include "dmx.h"
 #include "dmxsync.h"
 #include "dmxfont.h"
@@ -49,202 +47,6 @@
 #include "dixfont.h"
 #include "dixstruct.h"
 
-static int (*dmxSaveProcVector[256])(ClientPtr);
-static int   dmxFontLastError;
-
-static int dmxFontErrorHandler(Display *dpy, XErrorEvent *ev)
-{
-    dmxFontLastError = ev->error_code;
-
-    return 0;
-}
-
-static char **dmxGetFontPath(int *npaths)
-{
-    char          **fp;
-    unsigned char  *c, *paths;
-    char           *newfp;
-    int             len, l, i;
-
-    GetFontPath(serverClient, npaths, &len, &paths);
-
-    newfp = xalloc(*npaths + len);
-    c = (unsigned char *)newfp;
-    fp = xalloc(*npaths * sizeof(*fp));
-
-    memmove(newfp, paths+1, *npaths + len - 1);
-    l = *paths;
-    for (i = 0; i < *npaths; i++) {
-	fp[i] = (char *)c;
-	c += l;
-	l = *c;
-	*c++ = '\0';
-    }
-
-#if DMX_FONTPATH_DEBUG
-    for (i = 0; i < *npaths; i++)
-        dmxLog(dmxDebug, "FontPath[%d] = %s\n", i, fp[i]);
-#endif
-
-    return fp;
-}
-
-static void dmxFreeFontPath(char **fp)
-{
-    xfree(fp[0]);
-    xfree(fp);
-}
-
-static Bool dmxCheckFontPathElement(DMXScreenInfo *dmxScreen, char *fp)
-{
-    int  (*oldErrorHandler)(Display *, XErrorEvent *);
-
-    if (!dmxScreen->beDisplay)
-	return TRUE;
-
-    dmxFontLastError = 0;
-    oldErrorHandler = XSetErrorHandler(dmxFontErrorHandler);
-    XSetFontPath(dmxScreen->beDisplay, &fp, 1);
-    dmxSync(dmxScreen, TRUE);   /* Must complete before removing handler */
-    XSetErrorHandler(oldErrorHandler);
-
-    return (dmxFontLastError == 0);
-}
-
-static int dmxSetFontPath(DMXScreenInfo *dmxScreen)
-{
-    int  (*oldErrorHandler)(Display *, XErrorEvent *);
-    char **fp;
-    int    result = Success;
-    int    npaths;
-
-    if (!dmxScreen->beDisplay)
-	return result;
-
-    fp = dmxGetFontPath(&npaths);
-    if (!fp) return BadAlloc;
-
-    dmxFontLastError = 0;
-    oldErrorHandler = XSetErrorHandler(dmxFontErrorHandler);
-    XSetFontPath(dmxScreen->beDisplay, fp, npaths);
-    dmxSync(dmxScreen, TRUE);   /* Must complete before removing handler */
-    XSetErrorHandler(oldErrorHandler);
-
-    if (dmxFontLastError) {
-	result = dmxFontLastError;
-	/* We could set *error here to the offending path, but it is
-	 * ignored, so we don't bother figuring out which path is bad.
-	 * If we do add this support in the future, we'll need to add
-	 * error to the function's argument list.
-	 */
-    }
-
-    dmxFreeFontPath(fp);
-
-    return result;
-}
-
-static int dmxCheckFontPath(DMXScreenInfo *dmxScreen, int *error)
-{
-    char **oldFontPath;
-    int    nOldPaths;
-    int    result = Success;
-
-    if (!dmxScreen->beDisplay)
-	return result;
-
-    /* Save old font path */
-    oldFontPath = XGetFontPath(dmxScreen->beDisplay, &nOldPaths);
-
-    result = dmxSetFontPath(dmxScreen);
-
-    /* Restore old font path */
-    XSetFontPath(dmxScreen->beDisplay, oldFontPath, nOldPaths);
-    XFreeFontPath(oldFontPath);
-    dmxSync(dmxScreen, FALSE);
-
-    return result;
-}
-
-static int dmxProcSetFontPath(ClientPtr client)
-{
-    unsigned char *ptr;
-    unsigned long  nbytes, total, n;
-    long           nfonts;
-    int            i, result;
-    int            error;
-    unsigned char *oldFontPath, *tmpFontPath;
-    int            nOldPaths;
-    int            lenOldPaths;
-    REQUEST(xSetFontPathReq);
-    
-    REQUEST_AT_LEAST_SIZE(xSetFontPathReq);
-    
-    nbytes = (client->req_len << 2) - sizeof(xSetFontPathReq);
-    total = nbytes;
-    ptr = (unsigned char *)&stuff[1];
-    nfonts = stuff->nFonts;
-
-    while (--nfonts >= 0) {
-	if ((total == 0) || (total < (n = (*ptr + 1))))
-	    return BadLength;
-	total -= n;
-	ptr += n;
-    }
-    if (total >= 4)
-        return BadLength;
-
-    GetFontPath(serverClient, &nOldPaths, &lenOldPaths, &tmpFontPath);
-    oldFontPath = xalloc(nOldPaths + lenOldPaths);
-    memmove(oldFontPath, tmpFontPath, nOldPaths + lenOldPaths);
-
-    result = SetFontPath(client, stuff->nFonts, (unsigned char *)&stuff[1],
-			 &error);
-    if (!result) {
-	for (i = 0; i < dmxNumScreens; i++)
-	    if ((result = dmxCheckFontPath(&dmxScreens[i], &error)))
-		break;
-
-	if (result) {
-	    int  ignoreresult, ignoreerror;
-
-	    /* Restore old fontpath in the DMX server */
-	    ignoreresult = SetFontPath(client, nOldPaths, oldFontPath,
-				       &ignoreerror);
-	} else {
-	    result = client->noClientException;
-	    client->errorValue = error;
-	}
-    }
-
-    xfree(oldFontPath);
-    return result;
-}
-
-/** Initialize font support.  In addition to the screen function call
- *  pointers, DMX also hooks in at the ProcVector[] level.  Here the old
- *  ProcVector function pointers are saved and the new ProcVector
- *  function pointers are initialized. */
-void dmxInitFonts(void)
-{
-    int  i;
-
-    for (i = 0; i < 256; i++)
-	dmxSaveProcVector[i] = ProcVector[i];
-
-    ProcVector[X_SetFontPath] = dmxProcSetFontPath;
-}
-
-/** Reset font support by restoring the original ProcVector function
- *  pointers. */
-void dmxResetFonts(void)
-{
-    int  i;
-
-    for (i = 0; i < 256; i++)
-	ProcVector[i] = dmxSaveProcVector[i];
-}
-
 /** Load the font, \a pFont, on the back-end server associated with \a
  *  pScreen.  When a font is loaded, the font path on back-end server is
  *  first initialized to that specified on the command line with the
@@ -254,8 +56,6 @@ Bool dmxBELoadFont(ScreenPtr pScreen, Fo
     DMXScreenInfo  *dmxScreen = &dmxScreens[pScreen->myNum];
     dmxFontPrivPtr  pFontPriv = FontGetPrivate(pFont, dmxFontPrivateIndex);
     char           *name;
-    char          **oldFontPath = NULL;
-    int             nOldPaths;
     Atom            name_atom, value_atom;
     int             i;
 
@@ -268,141 +68,6 @@ Bool dmxBELoadFont(ScreenPtr pScreen, Fo
 	return TRUE; /* Already loaded font */
     }
 
-    /* Save old font path */
-    oldFontPath = XGetFontPath(dmxScreen->beDisplay, &nOldPaths);
-
-    /* Set the font path for the font about to be loaded on the back-end */
-    if (dmxSetFontPath(dmxScreen)) {
-	char **fp;
-	int    npaths;
-	Bool  *goodfps;
-
-	/* This could fail only when first starting the X server and
-	 * loading the default font.  If it fails here, then the default
-	 * font path is invalid, no default font path will be set, the
-	 * DMX server will fail to load the default font, and it will
-	 * exit with an error unless we remove the offending font paths
-	 * with the -ignorebadfontpaths command line option.
-	 */
-
-	fp = dmxGetFontPath(&npaths);
-	if (!fp) {
-	    dmxLog(dmxError,
-		   "No default font path set.\n");
-	    dmxLog(dmxError,
-		   "Please see the Xdmx man page for information on how to\n");
-	    dmxLog(dmxError,
-		   "initialize the DMX server's default font path.\n");
-	    XFreeFontPath(oldFontPath);
-	    return FALSE;
-	}
-
-	if (!dmxFontPath)
-	    dmxLog(dmxWarning, "No default font path is set.\n");
-
-	goodfps = xalloc(npaths * sizeof(*goodfps));
-
-	dmxLog(dmxError,
-	       "The DMX server failed to set the following font paths on "
-	       "screen #%d:\n", pScreen->myNum);
-	
-	for (i = 0; i < npaths; i++)
-	    if (!(goodfps[i] = dmxCheckFontPathElement(dmxScreen, fp[i])))
-		dmxLog(dmxError, "    %s\n", fp[i]);
-
-	if (dmxIgnoreBadFontPaths) {
-	    char *newfp;
-	    int   newnpaths = 0;
-	    int   len = 0;
-	    int   j = 0;
-	    int   error;
-
-	    dmxLog(dmxError,
-		   "These font paths will not be used because the "
-		   "\"-ignorebadfontpaths\"\n");
-	    dmxLog(dmxError,
-		   "option is set.\n");
-
-	    for (i = 0; i < npaths; i++)
-		if (goodfps[i]) {
-		    len += strlen(fp[i]) + 1;
-		    newnpaths++;
-		}
-
-	    if (!newnpaths) {
-		/* No valid font paths were found */
-		dmxLog(dmxError,
-		       "After removing the font paths above, no valid font "
-		       "paths were\n");
-		dmxLog(dmxError,
-		       "available.  Please check that the font paths set on "
-		       "the command\n");
-		dmxLog(dmxError,
-		       "line or in the configuration file via the "
-		       "\"-fontpath\" option\n");
-		dmxLog(dmxError,
-		       "are valid on all back-end servers.  See the Xdmx man "
-		       "page for\n");
-		dmxLog(dmxError,
-		       "more information on font paths.\n");
-		dmxFreeFontPath(fp);
-		XFreeFontPath(oldFontPath);
-		xfree(goodfps);
-		return FALSE;
-	    }
-
-	    newfp = xalloc(len * sizeof(*newfp));
-	    for (i = 0; i < npaths; i++) {
-		if (goodfps[i]) {
-		    int n = strlen(fp[i]);
-		    newfp[j++] = n;
-		    strncpy(&newfp[j], fp[i], n);
-		    j += n;
-		}
-	    }
-
-	    if (SetFontPath(serverClient, newnpaths, (unsigned char *)newfp,
-			    &error)) {
-		/* Note that this should never happen since all of the
-		 * FPEs were previously valid. */
-		dmxLog(dmxError, "Cannot reset the default font path.\n");
-	    }
-	} else if (dmxFontPath) {
-	    dmxLog(dmxError,
-		   "Please remove these font paths from the command line "
-		   "or\n");
-	    dmxLog(dmxError,
-		   "configuration file, or set the \"-ignorebadfontpaths\" "
-		   "option to\n");
-	    dmxLog(dmxError,
-		   "ignore them.  For more information on these options, see "
-		   "the\n");
-	    dmxLog(dmxError,
-		   "Xdmx man page.\n");
-	} else {
-	    dmxLog(dmxError,
-		   "Please specify the font paths that are available on all "
-		   "back-end\n");
-	    dmxLog(dmxError,
-		   "servers with the \"-fontpath\" option, or use the "
-                   "\"-ignorebadfontpaths\"\n");
-            dmxLog(dmxError,
-                   "to ignore bad defaults.  For more information on "
-                   "these and other\n");
-	    dmxLog(dmxError,
-		   "font-path-related options, see the Xdmx man page.\n");
-	}
-
-	if (!dmxIgnoreBadFontPaths ||
-	    (dmxIgnoreBadFontPaths && dmxSetFontPath(dmxScreen))) {
-	    /* We still have errors so return with error */
-	    dmxFreeFontPath(fp);
-	    XFreeFontPath(oldFontPath);
-	    xfree(goodfps);
-	    return FALSE;
-	}
-    }
-
     /* Find requested font on back-end server */
     name_atom = MakeAtom("FONT", 4, TRUE);
     value_atom = 0L;
@@ -418,12 +83,13 @@ Bool dmxBELoadFont(ScreenPtr pScreen, Fo
     name = (char *)NameForAtom(value_atom);
     if (!name) return FALSE;
 
-    pFontPriv->font[pScreen->myNum] = 
+    pFontPriv->font[pScreen->myNum] = None;
+
+    XLIB_PROLOGUE (dmxScreen);
+    pFontPriv->font[pScreen->myNum] =
 	XLoadQueryFont(dmxScreen->beDisplay, name);
+    XLIB_EPILOGUE (dmxScreen);
 
-    /* Restore old font path */
-    XSetFontPath(dmxScreen->beDisplay, oldFontPath, nOldPaths);
-    XFreeFontPath(oldFontPath);
     dmxSync(dmxScreen, FALSE);
 
     if (!pFontPriv->font[pScreen->myNum]) return FALSE;
@@ -472,7 +138,9 @@ Bool dmxBEFreeFont(ScreenPtr pScreen, Fo
     dmxFontPrivPtr  pFontPriv = FontGetPrivate(pFont, dmxFontPrivateIndex);
 
     if (pFontPriv && pFontPriv->font[pScreen->myNum]) {
+	XLIB_PROLOGUE (dmxScreen);
 	XFreeFont(dmxScreen->beDisplay, pFontPriv->font[pScreen->myNum]);
+	XLIB_EPILOGUE (dmxScreen);
 	pFontPriv->font[pScreen->myNum] = NULL;
 	return TRUE;
     }
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxfont.h
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxfont.h
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxfont.h
@@ -45,9 +45,6 @@ typedef struct _dmxFontPriv {
     XFontStruct **font;
 } dmxFontPrivRec, *dmxFontPrivPtr;
 
-extern void dmxInitFonts(void);
-extern void dmxResetFonts(void);
-
 extern Bool dmxRealizeFont(ScreenPtr pScreen, FontPtr pFont);
 extern Bool dmxUnrealizeFont(ScreenPtr pScreen, FontPtr pFont);
 
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxgc.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxgc.c
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxgc.c
@@ -60,8 +60,8 @@ static GCFuncs dmxGCFuncs = {
 };
 
 static GCOps dmxGCOps = {
-    dmxFillSpans,
-    dmxSetSpans,
+    NULL, /* dmxFillSpans */
+    NULL, /* dmxSetSpans */
     dmxPutImage,
     dmxCopyArea,
     dmxCopyPlane,
@@ -77,8 +77,8 @@ static GCOps dmxGCOps = {
     dmxPolyText16,
     dmxImageText8,
     dmxImageText16,
-    dmxImageGlyphBlt,
-    dmxPolyGlyphBlt,
+    NULL, /* dmxImageGlyphBlt */
+    NULL, /* dmxPolyGlyphBlt */
     dmxPushPixels
 };
 
@@ -106,9 +106,13 @@ void dmxBECreateGC(ScreenPtr pScreen, GC
 	    gcvals.graphics_exposures = FALSE;
 
 	    /* Create GC in the back-end servers */
+	    pGCPriv->gc = None;
+
+	    XLIB_PROLOGUE (dmxScreen);
 	    pGCPriv->gc = XCreateGC(dmxScreen->beDisplay,
 				    dmxScreen->scrnDefDrawables[i],
 				    mask, &gcvals);
+	    XLIB_EPILOGUE (dmxScreen);
 	    break;
 	}
     }
@@ -275,14 +279,20 @@ void dmxChangeGC(GCPtr pGC, unsigned lon
     if (mask & GCDashList) {
 	mask &= ~GCDashList;
 	if (dmxScreen->beDisplay)
+	{
+	    XLIB_PROLOGUE (dmxScreen);
 	    XSetDashes(dmxScreen->beDisplay, pGCPriv->gc,
 		       pGC->dashOffset, (char *)pGC->dash,
 		       pGC->numInDashList);
+	    XLIB_EPILOGUE (dmxScreen);
+	}
     }
     if (mask & GCArcMode)           v.arc_mode = pGC->arcMode;
 
     if (mask && dmxScreen->beDisplay) {
+	XLIB_PROLOGUE (dmxScreen);
 	XChangeGC(dmxScreen->beDisplay, pGCPriv->gc, mask, &v);
+	XLIB_EPILOGUE (dmxScreen);
 	dmxSync(dmxScreen, FALSE);
     }
 
@@ -303,7 +313,11 @@ void dmxCopyGC(GCPtr pGCSrc, unsigned lo
 
     /* Copy the GC on the back-end server */
     if (dmxScreen->beDisplay)
+    {
+	XLIB_PROLOGUE (dmxScreen);
 	XCopyGC(dmxScreen->beDisplay, pGCSrcPriv->gc, changes, pGCDstPriv->gc);
+	XLIB_EPILOGUE (dmxScreen);
+    }
 
     DMX_GC_FUNC_EPILOGUE(pGCDst);
 }
@@ -316,7 +330,9 @@ Bool dmxBEFreeGC(GCPtr pGC)
     dmxGCPrivPtr   pGCPriv   = DMX_GET_GC_PRIV(pGC);
 
     if (pGCPriv->gc) {
+	XLIB_PROLOGUE (dmxScreen);
 	XFreeGC(dmxScreen->beDisplay, pGCPriv->gc);
+	XLIB_EPILOGUE (dmxScreen);
 	pGCPriv->gc = NULL;
 	return TRUE;
     }
@@ -358,7 +374,11 @@ void dmxChangeClip(GCPtr pGC, int type,
     switch (pGC->clientClipType) {
     case CT_NONE:
 	if (dmxScreen->beDisplay)
+	{
+	    XLIB_PROLOGUE (dmxScreen);
 	    XSetClipMask(dmxScreen->beDisplay, pGCPriv->gc, None);
+	    XLIB_EPILOGUE (dmxScreen);
+	}
 	break;
 
     case CT_REGION:
@@ -374,20 +394,18 @@ void dmxChangeClip(GCPtr pGC, int type,
 		pRects[i].height = pBox[i].y2 - pBox[i].y1;
 	    }
 
+	    XLIB_PROLOGUE (dmxScreen);
 	    XSetClipRectangles(dmxScreen->beDisplay, pGCPriv->gc,
 			       pGC->clipOrg.x, pGC->clipOrg.y,
 			       pRects, nRects, Unsorted);
+	    XLIB_EPILOGUE (dmxScreen);
 
 	    xfree(pRects);
 	}
 	break;
 
-    case CT_PIXMAP:
-    case CT_UNSORTED:
-    case CT_YSORTED:
-    case CT_YXSORTED:
-    case CT_YXBANDED:
-	/* These clip types are condensed down to either NONE or REGION
+    default:
+	/* Other clip types are condensed down to either NONE or REGION
            in the mi code */
 	break;
     }
@@ -407,7 +425,11 @@ void dmxDestroyClip(GCPtr pGC)
 
     /* Set the client clip on the back-end server to None */
     if (dmxScreen->beDisplay)
+    {
+	XLIB_PROLOGUE (dmxScreen);
 	XSetClipMask(dmxScreen->beDisplay, pGCPriv->gc, None);
+	XLIB_EPILOGUE (dmxScreen);
+    }
 
     DMX_GC_FUNC_EPILOGUE(pGC);
 }
